/*============================================================================
  File:     multi_parm_agg.sql

  Summary:  Deployment and test script for multi-parameter 
			user-defined aggregate example.
			
			NOTE: Deploying multi-parameter user-defined aggregates is not 
			supported by Visual Studio autodeploy. Use this script and manual
			assembly and function deployment.

  Date:     August 2008

  SQL Server Version: 10.0.1600.22 (RTM)
------------------------------------------------------------------------------
  Written by Bob Beauchemin, SQLskills.com

  For more scripts and sample code, check out http://www.SQLskills.com

  This script is intended only as a supplement to SQL Server Jumpstart program. 
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/
sp_configure 'show advanced options', 1
reconfigure
go
sp_configure 'clr enabled', 1
reconfigure

if DATABASEPROPERTY('test', 'Version') is null
create database test
go

create assembly multiparmagg 
from 'C:\temp\MultiParmAgg.dll'

go


create aggregate covar_pop(@input1 decimal(20,10), @input2 decimal(20,10))
returns decimal(20,10)
external name multiparmagg.CovarPop;
go

create aggregate covar_float(@input1 float, @input2 float)
returns float
external name multiparmagg.CovarFloat;
go

--drop table test_covar;
--go

create table test_covar (
  i1 decimal(20,10),
  i2 decimal(20,10)
);
go

insert test_covar values(1,7);
insert test_covar values(2,1);
insert test_covar values(3,2);
insert test_covar values(4,5);
insert test_covar values(5,7);
insert test_covar values(6,34);
insert test_covar values(7,32);
insert test_covar values(8,43);
insert test_covar values(9,87);
go

select * from dbo.test_covar;
go

select dbo.covar_pop(i1, i2) from test_covar;

-- answer should  be 59.4444444
-- http://www.java2s.com/Code/Oracle/Analytical-Functions/COVARPOPexpr1expr2returnsapopulationcovariancebetweenexpr1andexpr2.htm
select dbo.covar_float(convert(float,i1), convert(float,i2)) from test_covar;

drop aggregate covar_float;
drop aggregate covar_pop;
drop assembly multiparmagg;