﻿using System;
using System.Collections;
using System.Text;
using Microsoft.SqlServer.Server;
using Microsoft.SqlServer.Types;

/*============================================================================
  File:     Class1.cs

  Summary:  Illustrates using SQLCLR functions with the hierarchyid data type
  
			NOTE: You must run the script PopulateHierarchy.sql in the 
			3-Beyond directory to be able to run the tests in this script.
  
			NOTE: You cannot deploy the assembly and functions using Visual Studio 
			autodeploy, you must use the script provided and manual assembly and UDF 
			deployment. 
  
  Date:     August 2008

  SQL Server Version: 10.0.1600.22 (RTM)
------------------------------------------------------------------------------
  Written by Bob Beauchemin, SQLskills.com

  For more scripts and sample code, check out http://www.SQLskills.com

  This script is intended only as a supplement to SQL Server Jumpstart program. 
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

public partial class HierarchyId_Operations
{
    [SqlFunction(FillRowMethodName = "FillRow_ListAncestors", TableDefinition="ancestor hierarchyid")]
    public static IEnumerable ListAncestors(SqlHierarchyId  h)
    {
        while (!h.IsNull)
        {
            yield return (h);
           h = h.GetAncestor(1);
        }
    }
    public static void FillRow_ListAncestors(Object obj, out SqlHierarchyId ancestor)
    {
        ancestor = (SqlHierarchyId)obj;
    }
}

