﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;

/*============================================================================
  File:     Concatenate.cs

  Summary:  Illustrates a large (> 8000 bytes) user-defined aggregate.
  
			NOTE: Deploying large user-defined aggregates is not 
			supported by Visual Studio autodeploy. Use the script provided and manual
			assembly and function deployment.

  Date:     August 2008

  SQL Server Version: 10.0.1600.22 (RTM)
------------------------------------------------------------------------------
  Written by Bob Beauchemin, SQLskills.com

  For more scripts and sample code, check out http://www.SQLskills.com

  This script is intended only as a supplement to SQL Server Jumpstart program.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

// 2147483648 bytes is 2gb
// you can't use -1 here
[Serializable]
//[Microsoft.SqlServer.Server.SqlUserDefinedAggregate(Format.UserDefined, MaxByteSize=2147483647, IsNullIfEmpty = true)]
[Microsoft.SqlServer.Server.SqlUserDefinedAggregate(Format.UserDefined, MaxByteSize=-1, IsNullIfEmpty = true)]
public struct Concatenate : IBinarySerialize
{
    String theanswer;

    public void Init()
    {
        theanswer = "";
    }

    public void Accumulate([SqlFacet(MaxSize=-1)]SqlString Value)
    {
        if (Value.IsNull)
            return;
        theanswer += Value.Value;
    }

    public void Merge(Concatenate Group)
    {
        theanswer += Group.theanswer;
    }

    [return: SqlFacet(MaxSize=-1)]
    public SqlString Terminate()
    {
        return theanswer;
    }

    public void Read(System.IO.BinaryReader r)
    {
        theanswer = r.ReadString();
    }

    public void Write(System.IO.BinaryWriter w)
    {
        // the values will always be non-null
        w.Write(theanswer);
    }
}
